##### Views

- Page
- Discussion
- View source
- History

# Mesh:setVertexMap

Available since LÖVE 0.9.0
This function is not supported in earlier versions.

Sets the vertex map for the Mesh. The vertex map describes the order in which the vertices are used when the Mesh is drawn. The vertices, vertex map, and mesh draw mode work together to determine what exactly is displayed on the screen.

The vertex map allows you to re-order or reuse vertices when drawing without changing the actual vertex parameters or duplicating vertices. It is especially useful when combined with different Mesh Draw Modes.

## Function

### Synopsis

Mesh:setVertexMap( map )

### Arguments

`table map`
  A table containing a list of vertex indices to use when drawing. Values must be in the range of [1, Mesh:getVertexCount()].

### Returns

Nothing.

## Function

### Synopsis

Mesh:setVertexMap( vi1, vi2, vi3, ... )

### Arguments

`number vi1`
  The index of the first vertex to use when drawing. Must be in the range of [1, Mesh:getVertexCount()].
`number vi2`
  The index of the second vertex to use when drawing.
`number vi3`
  The index of the third vertex to use when drawing.

### Returns

Nothing.

## Examples

Use a vertex map to fix a visual glitch without copy/pasting vertices.

function love.load()
image = love.graphics.newImage("pig.png")
local w,h = image:getDimensions()
-- We want to make a Mesh with 1 vertex in the middle of the image, and 4 at the corners.
local vertices = {
{w/2, h/2, 0.5, 0.5, 255, 0, 0}, -- Center vertex, with a red tint.
{0, 0, 0, 0, 255, 255, 255}, -- Top left.
{w, 0, 1, 0, 255, 255, 255}, -- Top right.
{w, h, 1, 1, 255, 255, 255}, -- Bottom right.
{0, h, 0, 1, 255, 255, 255}, -- Bottom left.
}
-- But there's a problem! The drawn mesh will have a big triangle missing on its left side.
-- This is because, in the default mesh draw mode ("fan"), the vertices don't "loop": the top left vertex (#2) is unconnected to the bottom left one (#5).
mesh = love.graphics.newMesh(vertices, image)
-- We could copy/paste the second vertex onto the end of the table of vertices.
-- But instead we can just change the vertex map!
mesh:setVertexMap(1, 2, 3, 4, 5, 2)
end
function love.draw()
love.graphics.draw(mesh, 0, 0)
end

## See Also

- Mesh
- Mesh:getVertexMap
- MeshDrawMode

## Other Languages

Dansk – Deutsch – English – Español – Français – Indonesia – Italiano – Lietuviškai – Magyar – Nederlands – Polski – Português – Română – Slovenský – Suomi – Svenska – Türkçe – Česky – Ελληνικά – Български – Русский – Српски – Українська – עברית – ไทย – 日本語 – 正體中文 – 简体中文 – Tiếng Việt – 한국어
More info

Retrieved from "https://www.love2d.org/wiki/Mesh:setVertexMap"
Categories: Templates | Functions

##### Personal tools

- Log in

##### Search

##### Toolbox

- What links here
- Related changes
- Special pages
- Printable version
- Permanent link
- Browse properties